package net.ihe.gazelle.xdstar.epsos.ws;

/**
 * Please modify this class to meet your needs
 * This class is not complete
 */

import net.ihe.gazelle.query.AdhocQueryRequestType;
import net.ihe.gazelle.query.AdhocQueryResponseType;
import net.ihe.gazelle.query.ResponseOptionType;
import net.ihe.gazelle.query.ReturnTypeType;
import net.ihe.gazelle.rim.*;
import net.ihe.gazelle.rs.RegistryErrorListType;
import net.ihe.gazelle.rs.RegistryErrorType;
import net.ihe.gazelle.rs.RegistryResponseType;
import net.ihe.gazelle.simulator.common.model.ApplicationConfiguration;
import net.ihe.gazelle.util.Pair;
import net.ihe.gazelle.xds.RetrieveDocumentSetRequestType;
import net.ihe.gazelle.xds.RetrieveDocumentSetResponseType;
import net.ihe.gazelle.xdstar.common.model.MetadataMessage;
import net.ihe.gazelle.xdstar.common.model.MetadataMessageType;
import net.ihe.gazelle.xdstar.comon.util.XDSNamespacePrefixMapper;
import net.ihe.gazelle.xdstar.mtom.utils.MarshallRetrieveMTOM;
import org.jboss.seam.annotations.Name;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.annotation.Resource;
import javax.ejb.Stateless;
import javax.jws.HandlerChain;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.soap.SOAPBinding;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.servlet.http.HttpServletRequest;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.ws.Action;
import javax.xml.ws.BindingType;
import javax.xml.ws.WebServiceContext;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.soap.Addressing;
import java.io.ByteArrayOutputStream;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import static org.apache.commons.lang.CharEncoding.UTF_8;

/**
 * This class was generated by Apache CXF 2.7.6 2013-09-11T10:33:05.934+02:00
 * Generated source version: 2.7.6
 */
@Stateless
@Name("RespondingGatewayQueryWS")
@javax.jws.WebService(name = "RespondingGatewayQuery", serviceName = "RespondingGateway_Service", portName = "RespondingGatewayQuery_Port_Soap12",
        targetNamespace = "urn:ihe:iti:xds-b:2007")
@SOAPBinding(style = SOAPBinding.Style.DOCUMENT, parameterStyle = SOAPBinding.ParameterStyle.BARE)
@BindingType(javax.xml.ws.soap.SOAPBinding.SOAP12HTTP_MTOM_BINDING)
@Addressing(enabled = true)
@HandlerChain(file = "/handlers.xml")
public class RespondingGatewayQueryPortTypeImpl {

    private static final Logger LOG = LoggerFactory.getLogger(RespondingGatewayQueryPortTypeImpl.class);

    @PersistenceContext(unitName = "XDStarClient-PersistenceUnit")
    private EntityManager em;

    @Resource
    WebServiceContext wsContext;

    /*
     * (non-Javadoc)
     *
     * @see net.ihe.gazelle.xdstar.validator.ws.RespondingGatewayQueryPortType#
     * respondingGatewayCrossGatewayQuery
     * (net.ihe.gazelle.xdstar.validator.ws.AdhocQueryRequest body )*
     */
    @WebResult(name = "AdhocQueryResponse", targetNamespace = "urn:oasis:names:tc:ebxml-regrep:xsd:query:3.0", partName = "body")
    @Action(input = "urn:ihe:iti:2007:CrossGatewayQuery", output = "urn:ihe:iti:2007:CrossGatewayQueryResponse")
    @WebMethod(operationName = "RespondingGateway_CrossGatewayQuery", action = "urn:ihe:iti:2007:CrossGatewayQuery")
    public AdhocQueryResponseType respondingGatewayCrossGatewayQuery(
            AdhocQueryRequestType body) {
        String xdstoolWsdlLocation = ApplicationConfiguration
                .getValueOfVariable("xdstool_xca_query_wsdl");
        RespondingGatewayQueryPortTypeClient client = new RespondingGatewayQueryPortTypeClient();
        AdhocQueryResponseType aqr = null;
        try {
            aqr = client
                    .sendAndGetAdhocQueryResponse(body, xdstoolWsdlLocation);
        } catch (Exception e) {
            LOG.error("" + e.getMessage());
        }
        if (aqr == null) {
            return generateErrorAdhocResponse();
        }

        List<ExtrinsicObjectType> listExtrinsicObjectType = this
                .extractListExtrinsicObjectType(aqr);
        if (listExtrinsicObjectType != null
                && listExtrinsicObjectType.size() > 0) {
            List<AssociationType1> listAssociationRelatedToExtrinsicObjectPivot = new ArrayList<AssociationType1>();
            for (ExtrinsicObjectType extrinsicObjectType : listExtrinsicObjectType) {
                this.extractAssociationFromDocumentEntry(extrinsicObjectType,
                        listAssociationRelatedToExtrinsicObjectPivot);
            }
            aqr = this.createFinalAdhocQueryResponse(aqr,
                    listAssociationRelatedToExtrinsicObjectPivot);
        }
        saveMessageSent(aqr);
        return aqr;
    }

    @WebResult(name = "RetrieveDocumentSetResponse", targetNamespace = "urn:ihe:iti:xds-b:2007", partName = "body")
    @Action(input = "urn:ihe:iti:2007:CrossGatewayRetrieve", output = "urn:ihe:iti:2007:CrossGatewayRetrieveResponse")
    @WebMethod(operationName = "RespondingGateway_CrossGatewayRetrieve", action = "urn:ihe:iti:2007:CrossGatewayRetrieve")
    public RetrieveDocumentSetResponseType respondingGatewayCrossGatewayRetrieve(
            @WebParam(partName = "body", name = "RetrieveDocumentSetRequest", targetNamespace = "urn:ihe:iti:xds-b:2007")
                    RetrieveDocumentSetRequestType body) {
        String xdstoolWsdlLocation = ApplicationConfiguration.getValueOfVariable("xdstool_xca_query_wsdl");
        RetrieveDocumentSetResponseType ret = null;
        try {
            Pair<String, String> res = (new RespondingGatewayRetrievePortTypeClient()).send(body, xdstoolWsdlLocation);
            ret = MarshallRetrieveMTOM.transformMTOM2RetrieveDocumentResponse(res.getObject2(), res.getObject1());
        } catch (Exception e) {
            ret = new RetrieveDocumentSetResponseType();
            ret.setRegistryResponse(new RegistryResponseType());
            ret.getRegistryResponse().setStatus("urn:oasis:names:tc:ebxml-regrep:ResponseStatusType:Failure");
            ret.getRegistryResponse().setRegistryErrorList(new RegistryErrorListType());
            ret.getRegistryResponse().getRegistryErrorList().getRegistryError().add(new RegistryErrorType());
            ret.getRegistryResponse().getRegistryErrorList().getRegistryError().get(0).setErrorCode("XDSUnknownStoredQuery");
            ret.getRegistryResponse().getRegistryErrorList().getRegistryError().get(0).setSeverity
                    ("urn:oasis:names:tc:ebxml-regrep:ErrorSeverityType:Error");
            ret.getRegistryResponse().getRegistryErrorList().getRegistryError().get(0)
                    .setCodeContext("There are an internal error. Please try later or contact the administrator.");
        }
        saveMessageSent(ret);
        return ret;
    }

    private void saveMessageSent(RetrieveDocumentSetResponseType ret) {
        XGQResondingMessage respmsg = XGQResondingMessage
                .getResondingMessageByIpWhereSentMessageContentIsNull(
                        getIpAddress(), em);
        if (respmsg != null) {
            respmsg.setSentMessageContent(new MetadataMessage());
            respmsg.getSentMessageContent().setMessageContent(
                    RespondingGatewayRetrievePortTypeClient.getRetrieveDocumentSetResponseTypeAsString(ret));
            respmsg.getSentMessageContent().setMessageType(
                    MetadataMessageType.RETRIEVE_DOCUMENT_SET_RESPONSE);
            em.merge(respmsg);
            em.flush();
        }
    }

    private void saveMessageSent(AdhocQueryResponseType aqr) {
        XGQResondingMessage respmsg = XGQResondingMessage
                .getResondingMessageByIpWhereSentMessageContentIsNull(
                        getIpAddress(), em);
        if (respmsg != null) {
            respmsg.setSentMessageContent(new MetadataMessage());
            respmsg.getSentMessageContent().setMessageContent(
                    this.getAdhocQueryAsString(aqr));
            respmsg.getSentMessageContent().setMessageType(
                    MetadataMessageType.ADHOC_QUERY_RESPONSE);
            em.merge(respmsg);
            em.flush();
        }
    }

    private AdhocQueryResponseType generateErrorAdhocResponse() {
        AdhocQueryResponseType resp = new AdhocQueryResponseType();
        resp.setStatus("urn:oasis:names:tc:ebxml-regrep:ResponseStatusType:Failure");
        resp.setRegistryObjectList(new RegistryObjectListType());
        resp.setRegistryErrorList(new RegistryErrorListType());
        resp.getRegistryErrorList().getRegistryError()
                .add(new RegistryErrorType());
        resp.getRegistryErrorList().getRegistryError().get(0)
                .setErrorCode("XDSUnknownStoredQuery");
        resp.getRegistryErrorList()
                .getRegistryError()
                .get(0)
                .setSeverity(
                        "urn:oasis:names:tc:ebxml-regrep:ErrorSeverityType:Error");
        resp.getRegistryErrorList()
                .getRegistryError()
                .get(0)
                .setCodeContext(
                        "There are an internal error. Please try later or contact the administrator.");
        return resp;
    }

    private List<ExtrinsicObjectType> extractListExtrinsicObjectType(
            AdhocQueryResponseType aqr) {
        if (aqr != null && aqr.getRegistryObjectList() != null) {
            List<ExtrinsicObjectType> res = new ArrayList<ExtrinsicObjectType>();
            for (ExtrinsicObjectType extrinsicObjectType : aqr
                    .getRegistryObjectList().getExtrinsicObject()) {
                if (this.isAPatientSummaryDocument(extrinsicObjectType)) {
                    res.add(extrinsicObjectType);
                }
            }
            return res;
        }
        return null;
    }

    private boolean isAPatientSummaryDocument(
            ExtrinsicObjectType extrinsicObjectType) {
        for (ClassificationType cl : extrinsicObjectType.getClassification()) {
            if ((cl.getClassificationScheme() != null)
                    && cl.getClassificationScheme().equals(
                    "urn:uuid:41a5887f-8865-4c09-adf7-e362475b143a")
                    && cl.getNodeRepresentation().equals("60591-5")) {
                return true;
            }
        }
        return false;
    }

    private AdhocQueryResponseType createFinalAdhocQueryResponse(
            AdhocQueryResponseType aqr,
            List<AssociationType1> listAssociationRelatedToPSPivot) {
        for (AssociationType1 associationType1 : listAssociationRelatedToPSPivot) {
            aqr.getRegistryObjectList().addAssociation(associationType1);
        }
        return aqr;
    }

    private void extractAssociationFromDocumentEntry(
            ExtrinsicObjectType extrinsicObjectType,
            List<AssociationType1> listAssociationRelatedToPSPivot) {
        AdhocQueryRequestType quer = new AdhocQueryRequestType();
        quer.setResponseOption(new ResponseOptionType());
        quer.getResponseOption().setReturnComposedObjects(true);
        quer.getResponseOption().setReturnType(ReturnTypeType.LEAFCLASS);
        quer.setAdhocQuery(new AdhocQueryType());
        quer.getAdhocQuery().setHome("urn:oid:2.16.17.710.812.1000.990.1");
        quer.getAdhocQuery().setId(
                "urn:uuid:a7ae438b-4bc2-4642-93e9-be891f7bb155");
        quer.getAdhocQuery().getSlot().add(new SlotType1());
        quer.getAdhocQuery().getSlot().get(0).setName("$uuid");
        quer.getAdhocQuery().getSlot().get(0).setValueList(new ValueListType());
        quer.getAdhocQuery().getSlot().get(0).getValueList().getValue()
                .add("('" + extrinsicObjectType.getId() + "')");
        String xdstoolWsdlLocation = ApplicationConfiguration
                .getValueOfVariable("xdstool_xca_query_wsdl");
        RespondingGatewayQueryPortTypeClient client = new RespondingGatewayQueryPortTypeClient();
        AdhocQueryResponseType aqr = null;
        try {
            aqr = client
                    .sendAndGetAdhocQueryResponse(quer, xdstoolWsdlLocation);
        } catch (Exception e) {
            LOG.error("" + e.getMessage());
        }
        if (aqr == null) {
            return;
        }
        if (aqr.getRegistryObjectList() != null
                && aqr.getRegistryObjectList().getAssociation() != null) {
            for (AssociationType1 associationType1 : aqr
                    .getRegistryObjectList().getAssociation()) {
                if (associationType1.getAssociationType() != null
                        && associationType1.getAssociationType().equals(
                        "urn:ihe:iti:2007:AssociationType:XFRM")
                        && associationType1.getTargetObject().equals(
                        extrinsicObjectType.getId())) {
                    listAssociationRelatedToPSPivot.add(associationType1);
                }
            }
        }
    }

    private String getAdhocQueryAsString(Object aqr) {
        try {
            JAXBContext jc = JAXBContext.newInstance("net.ihe.gazelle.query");
            Marshaller m = jc.createMarshaller();
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
            m.setProperty("com.sun.xml.bind.namespacePrefixMapper",
                    new XDSNamespacePrefixMapper());
            m.marshal(aqr, baos);
            return baos.toString(UTF_8);
        } catch (UnsupportedEncodingException e) {
            LOG.error("" + e.getMessage());
        } catch (JAXBException e) {
            LOG.error("" + e.getMessage());
        }
        return null;
    }

    private String getIpAddress() {
        MessageContext mc = wsContext.getMessageContext();
        HttpServletRequest req = (HttpServletRequest) mc
                .get(MessageContext.SERVLET_REQUEST);
        return req.getRemoteAddr();
    }

}
